package org.firstinspires.ftc.teamcode;

import com.qualcomm.robotcore.eventloop.opmode.Disabled;
import com.qualcomm.robotcore.eventloop.opmode.OpMode;
import com.qualcomm.robotcore.eventloop.opmode.TeleOp;
import com.qualcomm.robotcore.hardware.Gamepad;

import org.firstinspires.ftc.teamcode.subsystem.ArmSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.ClawSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.LiftSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.MotorsSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.WristSubsystem;

@TeleOp(name = "Dev Teleop Remix", group = "Debug")
@Disabled
public class DevTeleOpRemix extends OpMode {

    public ClawSubsystem claw;
    public ArmSubsystem arm;
    public WristSubsystem wrist;
    public LiftSubsystem lift;
    public MotorsSubsystem motors;

    public Gamepad currentGamepad1;
    public Gamepad previousGamepad1;
    public Gamepad currentGamepad2;
    public Gamepad previousGamepad2;

    public double power = .6;

    @Override
    public void init() {

        claw = new ClawSubsystem(hardwareMap, telemetry);
        arm = new ArmSubsystem(hardwareMap, telemetry);
        wrist = new WristSubsystem(hardwareMap, telemetry);
        lift = new LiftSubsystem(hardwareMap, telemetry);
        motors = new MotorsSubsystem(hardwareMap, telemetry, power);

        claw.init();
        arm.init();
        wrist.init();
        lift.init();
        motors.init();

        currentGamepad1 = new Gamepad();
        previousGamepad1 = new Gamepad();
        currentGamepad2 = new Gamepad();
        previousGamepad2 = new Gamepad();
    }

    public void theDrop(ArmSubsystem arm, WristSubsystem wrist) {
        if (currentGamepad1.a && !previousGamepad1.a) {
            wrist.toFloorPosition();
            arm.toFloorPosition();
        }
    }

    public void thePickup(ClawSubsystem claw) {
        if (currentGamepad1.x && !previousGamepad1.x) {
            claw.switchState();
        }
    }

    public void theLift(ArmSubsystem arm, WristSubsystem wrist) {
        if (currentGamepad1.b && !previousGamepad1.b) {
            arm.toParkPosition();
            wrist.toBucketPosition();
        }
    }

    public void theLowBucketScore(LiftSubsystem lift, WristSubsystem wrist, ArmSubsystem arm) {
        if (currentGamepad1.y && !previousGamepad1.y) {
            lift.toLowBucket();
            wrist.toBucketPosition();
        }
    }

    @Override
    public void loop() {

        previousGamepad1.copy(currentGamepad1);
        currentGamepad1.copy(gamepad1);

        previousGamepad2.copy(currentGamepad2);
        currentGamepad2.copy(gamepad2);

        theDrop(arm, wrist);
        thePickup(claw);
        theLift(arm, wrist);
        theLowBucketScore(lift, wrist, arm);

        motors.calculateTrajectory(gamepad1);

    }

}
